"""Autogenerated SQLAlchemy models based on OpenAlchemy models."""
# pylint: disable=no-member,useless-super-delegation

import typing

import sqlalchemy
from sqlalchemy import orm

from open_alchemy import models


class PayInfoDict(typing.TypedDict, total=False):
    """TypedDict for properties that are not required."""

    id: typing.Optional[int]
    account_number: typing.Optional[str]


class PayInfo(models.PayInfo):  # type: ignore
    """SQLAlchemy model."""

    # SQLAlchemy properties
    __table__: sqlalchemy.Table
    __tablename__: str
    query: orm.Query

    # Model properties
    id: typing.Optional[int]
    account_number: typing.Optional[str]
    employee: typing.Optional["Employee"]

    def __init__(
        self,
        id: typing.Optional[int] = None,
        account_number: typing.Optional[str] = None,
    ) -> None:
        """Construct."""
        kwargs = {}
        if id is not None:
            kwargs["id"] = id
        if account_number is not None:
            kwargs["account_number"] = account_number

        super().__init__(**kwargs)

    @classmethod
    def from_dict(
        cls,
        id: typing.Optional[int] = None,
        account_number: typing.Optional[str] = None,
    ) -> "PayInfo":
        """Construct from a dictionary (eg. a POST payload)."""
        kwargs = {}
        if id is not None:
            kwargs["id"] = id
        if account_number is not None:
            kwargs["account_number"] = account_number

        return super().from_dict(**kwargs)

    def to_dict(self) -> PayInfoDict:
        """Convert to a dictionary (eg. to send back for a GET request)."""
        return super().to_dict()


class EmployeeDict(typing.TypedDict, total=True):
    """TypedDict for properties that are required."""

    id: int
    name: str
    pay_info: "PayInfoDict"


class Employee(models.Employee):  # type: ignore
    """SQLAlchemy model."""

    # SQLAlchemy properties
    __table__: sqlalchemy.Table
    __tablename__: str
    query: orm.Query

    # Model properties
    id: int
    name: str
    pay_info: "PayInfo"

    def __init__(self, id: int, name: str, pay_info: "PayInfo") -> None:
        """Construct."""
        kwargs = {"id": id, "name": name, "pay_info": pay_info}

        super().__init__(**kwargs)

    @classmethod
    def from_dict(cls, id: int, name: str, pay_info: "PayInfoDict") -> "Employee":
        """Construct from a dictionary (eg. a POST payload)."""
        kwargs = {"id": id, "name": name, "pay_info": pay_info}

        return super().from_dict(**kwargs)

    def to_dict(self) -> EmployeeDict:
        """Convert to a dictionary (eg. to send back for a GET request)."""
        return super().to_dict()
